// Jonathan Huang
// Created 2/6/2001; 9:22:55 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File

typedef struct 
{
   int x;
   int y;
} coord;
   
coord midpoint(coord a, coord b)
{
   coord result = {(a.x + b.x) / 2, (a.y + b.y) / 2};
   return result;
}
// Main Function
void dragon(coord a,coord b, coord c,int iterations)
{
		coord peakCB,peakAC;
   	if(iterations == 0) return;
   	peakCB = midpoint(a,b);
    peakAC.x = a.x + c.x - peakCB.x;
    peakAC.y = a.y + c.y - peakCB.y;
		
   	if(iterations == 1)  //wait until final recursive level to draw
   	{
    	DrawLine(a.x,a.y,peakAC.x,peakAC.y,A_NORMAL);
    	DrawLine(peakAC.x,peakAC.y,c.x,c.y,A_NORMAL);
    	DrawLine(c.x,c.y,peakCB.x,peakCB.y,A_NORMAL);
    	DrawLine(peakCB.x,peakCB.y,b.x,b.y,A_NORMAL);
    }
    dragon(a,c,peakAC,iterations - 1);
    dragon(b,c,peakCB,iterations - 1);
}

void _main(void)
{
	coord a = {40,70},b = {120,70},c = {80,30};
	LCD_BUFFER buffer;
	LCD_save (buffer);

	clrscr ();
  dragon(a,b,c,10);
	ngetchx ();
	LCD_restore (buffer);

	return;
}
